#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>
#define NUM_THREADS  2
#define TCOUNT 10000000
#undef SYNC
#define SYNC

int     count = 0;
int     thread_ids[2] = {0,1};
int     thr_count[2] = {0,0};
#ifdef SYNC
pthread_mutex_t count_lock=PTHREAD_MUTEX_INITIALIZER; 
#endif

void *inc_count(void *idp)
{
  int *my_id = idp;

  while (1) {
#ifdef SYNC
    pthread_mutex_lock(&count_lock);
#endif
    if (count >= TCOUNT) break;
    thr_count[*my_id]++;
    count++;
#ifdef SYNC
    pthread_mutex_unlock(&count_lock);
#endif
  }
#ifdef SYNC
  pthread_mutex_unlock(&count_lock);
#endif
  
  return(NULL);
}

int main()
{
  int       i;
  pthread_t threads[2];

  pthread_create(&threads[0], NULL, inc_count, (void *)&thread_ids[0]);
  pthread_create(&threads[1], NULL, inc_count, (void *)&thread_ids[1]);

  for (i = 0; i < NUM_THREADS; i++) {
    pthread_join(threads[i], NULL);
  }
  printf(" %d %d %d %d\n", thr_count[0],thr_count[1],thr_count[0]+thr_count[1],count);
  exit(0);
}


