#include   <signal.h>
#include   <stdio.h>
#include   <stdlib.h>
#include   <unistd.h>

void err_sys(char *s)
{
    fprintf(stderr,"%s\n",s);
    exit(1);
}

void sig_quit(int signo)
{
   printf("\nStart Signalroutine fuer SIGQUIT\n");
   printf("Ende Signalroutine fuer SIGQUIT\n\n");
   return;
}

int main()
{
   sigset_t   newmask, oldmask, pendmask;

   if (signal(SIGQUIT, sig_quit) == SIG_ERR)
      err_sys("Signalroutine fuer SIGQUIT nicht setzbar");
   sigemptyset(&newmask);
   sigaddset(&newmask, SIGQUIT);
               /* blockieren von SIGQUIT  */
   if (sigprocmask(SIG_BLOCK, &newmask, &oldmask) < 0)
      err_sys("sigprocmask Fehler, SIG_BLOCK nicht erfolgreich");
   printf("\nPID=%d, SIGQUIT: %d \n",(int) getpid(),SIGQUIT);
   printf("Wir warten jetzt 15 Sekunden auf SIGQUIT (CNTRL/\\)\n");
   printf("SIGQUIT ist dabei blockiert.\n");
   sleep(15);      /* hier wird gewartet, SIGQUIT bleibt haengen  */
   if (sigpending(&pendmask) < 0)
      err_sys("sigpending Fehler");
   if (sigismember(&pendmask, SIGQUIT))
      printf("\nSignal SIGQUIT ist zuvor aufgetreten\n");
   else
      printf("Signal SIGQUIT ist zuvor nicht aufgetreten\n");
               /* ruecksetzen der Signalmaske mit ungeblocktem SIGQUIT */
   printf("Signal SIGQUIT   wird   wieder zulassen\n");
   if (sigprocmask(SIG_SETMASK, &oldmask, NULL) < 0)
      err_sys("SIG_SETMASK Fehler");
   printf("Signal SIGQUIT   wurde   wieder zugelassen\n");
   if (signal(SIGQUIT, SIG_DFL) == SIG_ERR)
      err_sys("can't reset SIGQUIT");
   printf("Signalroutine fuer SIGQUIT wird auf SIG_DFL zurueckgesetzt\n");
   printf("wir warten noch 10 Sekunden\n");
   sleep(10);      /* SIGQUIT erzeugt hierhere einen Abbruch mit core-File */
   printf("Programm zu Ende\n\n");
   exit(0);
}
