 /*
 * sig1.c
 * Einfaches Beispiel fuer  Pthreads und Signale.
 */
#include <pthread.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>

#define MAX_NUM_THREADS  6
pthread_t threads[MAX_NUM_THREADS];
int threadnumber[MAX_NUM_THREADS];
int       num_threads = 0;
pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;
int zykles;

void signal_handler(int sig) 
{ int i;
  pthread_t akt_thread;
  akt_thread=pthread_self();
  for (i=0; i< num_threads; i++) 
    if ( akt_thread == threads[i] ) break;
  printf("%d: signal_handler(): Thread %d (%02d) aufgetreten\n",
                 (int) getpid(),i, (unsigned int) akt_thread%100);
  return;
}

void *worker(int *p)
{
  time_t now; 
  struct sigaction action;
  sigset_t  sig_mask;
  int maxzkl=5;

  action.sa_flags=0;
  sigemptyset(&sig_mask);
  sigfillset(&sig_mask); 
  action.sa_mask = sig_mask;
  action.sa_handler=signal_handler;
  sigaction(SIGUSR1, &action, NULL);
  sigaction(SIGUSR2, &action, NULL);
  sigemptyset(&sig_mask);
  sigaddset(&sig_mask,SIGUSR1);
  sigprocmask(SIG_UNBLOCK,&sig_mask,NULL);

  /* Aktueller Thread */
  while (maxzkl--) {
      now=time(NULL); 
      printf("%d: worker(): Thread %d (%02d) - arbeitet(%ld)\n",
              (int) getpid(),*p, (unsigned int) pthread_self()%100,now);
      pthread_mutex_lock(&lock);
      zykles=*p;
      pthread_mutex_unlock(&lock);
      sleep(6*((*p)+1));
      now=time(NULL); 
      printf("%d: worker(): Thread %d (%02d) - Zyklus fertig(%ld)\n",
              (int)getpid(),*p, (unsigned int) pthread_self()%100,now);
  }
  pthread_exit((void *) NULL);
}

int main()
{
  int       i;
  sigset_t  sig_mask;

  sigemptyset(&sig_mask);
  sigaddset(&sig_mask,SIGUSR1);
  sigaddset(&sig_mask,SIGUSR2);
  sigprocmask(SIG_BLOCK,&sig_mask,NULL);

  /* aktueller Thread */
  threadnumber[num_threads]=0;
  printf("%d: main(): Thread %d (0x%x)\n", 
     (int) getpid(),num_threads++, (unsigned int) pthread_self()); 
  printf("%d: Sende SIGUSR1(%d) und SIGUSR2(%d)\n",
            (int)getpid(),SIGUSR1,SIGUSR2);
  /* starte Thread */
  for ( ; num_threads < MAX_NUM_THREADS-1; num_threads++) {
      threadnumber[num_threads]=num_threads;
      pthread_create(&threads[num_threads],
		 NULL,
                 (void *)worker,
		 &threadnumber[num_threads]);
      printf("main(): Thread %d erzeugen\n",num_threads);
  }
  printf("%d: main(): warten auf das Ende der Threads\n",(int)getpid());
  for (i = 1; i < MAX_NUM_THREADS-1; i++) {
    pthread_join(threads[i], NULL);
    printf("%d: main(): Ende von Thread %d \n",(int)getpid(),i);
  }
  printf("%d: main(): alle %d Threads sind fertig. \n", 
          (int)getpid(),num_threads);
  exit(0);
}

