/*
 * simple_mutex.c
 * Simple multi-threaded example using mutex 
 * to protect shared data.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

void do_thread(int *);
void do_wrap_up(int, int);

int r1 = 0, r2 = 0;
int glb = 0;
pthread_mutex_t glb_mutex;

void prdo(char *text, int glb, int loc, int stloc)
{  unsigned int id;

   id=(unsigned int) pthread_self() % 100;
   printf("%d: thread: %02u - glb=%d, loc=%d, stloc=%d, %s\n",
          (int) getpid(),id,glb,loc,stloc,text);
}

void busy(int v)
{ int i,j,k;
  float r,s;

  r=1.0; s=2.0;
  for (i=1; i<v; i++) 
    for (j=1; j<v; j++) 
      for (k=1; k<v; k++) {
         s=(s+1.123)*2.3; r=r*s;
      }
}

int main()
{ pthread_t       thread1, thread2;

  pthread_mutex_init(&glb_mutex, NULL);
  pthread_create(&thread1, NULL, (void *) do_thread, (void *) &r1); 
  pthread_create(&thread2, NULL, (void *) do_thread, (void *) &r2); 
  pthread_join(thread1, NULL);
  printf("main: 1.Thread fertig\n");
  pthread_join(thread2, NULL);
  printf("main: 2.Thread fertig\n");
  do_wrap_up(r1, r2);
  exit(0);
}

void do_thread(int *pnum_times)
{ int  i, j, loc; static int stloc=0;
 
  loc=0;
  prdo("start",glb,loc,stloc);
  for (i = 0;  i < 4; i++) {
    prdo("vor mutex_lock",glb,loc,stloc);
    j=stloc;j++;
    pthread_mutex_lock(&glb_mutex);
    prdo("mutex_locked", glb,loc,stloc);
    glb++; loc++; 
    (*pnum_times)++;
    busy(50);
    prdo("mutex_unlock",glb,loc,stloc);
    pthread_mutex_unlock(&glb_mutex); 
    stloc=j;
    prdo("mutex_unlocked",glb,loc,stloc);
    /*busy(49);*/
    busy(49);
  }
  prdo("fertig",glb,loc,stloc);
  pthread_exit(NULL);
}

void do_wrap_up(int one_times, int another_times)
{ int total;

  total = one_times + another_times;
  printf("All done, one thing %d, another %d for a total of %d\n",
	one_times, another_times, total);
}
